<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 35.10</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center p-2">Danh Sách Người Dùng</h2>
            </div>
        </div>
        <div class="container-fluid jumbotron">
            <div class="row form-group">
                <div class="col-sm-2 col-form-label">
                    <label for="">Name: </label>
                </div>
                <div class="col-sm-8">
                    <input type="text" id="inp-name" class="form-control">
                </div>
                <div class="col-sm-2">
                    <button class="btn btn-success" id="btn-filter">Filter user</button>
                </div>
            </div>
        </div>
        <div class="container-fluid">
            <div class="row form-group">
                <div class="col-sm-12 text-nowrap">
                    <table class="table table-bordered table-striped table-hover" id="table-users">
                        <thead class="text-white thead-dark">
                            <tr class="text-center">
                                <th scope="col">STT</th>
                                <th scope="col">Name</th>
                                <th scope="col">Username</th>
                                <th scope="col">Email</th>
                                <th scope="col">Address</th>
                                <th scope="col">Zip code</th>
                                <th scope="col">Phone</th>
                                <th scope="col">Company</th>
                                <th scope="col">Action</th>
                            </tr>
                        </thead>
                        <tbody>

                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gUsersArr = [];
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    $(document).on("click", ".btn-detail", function () {
        console.log("Nút chi tiết được ấn!");
        //console.log("id: " + $(this).data("id"));
        const vDETAIL_FORM_URL = "userdetail.html";
        var vUrlOpen = vDETAIL_FORM_URL + "?id=" + $(this).data("id");
        window.location.href = vUrlOpen;
    });
    $("#btn-filter").on("click", onBtnFilterClick);
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        //Call api server
        $.ajax({
            url: "https://jsonplaceholder.typicode.com/users/",
            type: "GET",
            dataType: "json",
            success: function (paramResponse) {
                gUsersArr = paramResponse
                //console.log(gUsersArr);
                showAllDataUser(paramResponse);
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText);
            }
        });
    }
    function onBtnFilterClick() {
        var vUser = {
            name: ""
        }
        getFilterUser(vUser);
        var vValid = checkFilterData(vUser);
        if (vValid) {
            var vUserFiltered = findUserByFilter(vUser);
            var vTable = $("#table-users");
            vTable.find("tr:gt(0)").html("");
            if (vUserFiltered.length > 0) {
                alert("Tìm thấy: " + vUserFiltered.length);
                showAllDataUser(vUserFiltered);
            }
            else {
                alert("Không tìm thấy kết quả phù hợp");
                return false;
            }
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //
    function showAllDataUser(paramArray) {
        for (var bI = 0; bI < paramArray.length; bI++) {
            var bRow = "";
            bRow += "<tr>";
            bRow += "<td>" + paramArray[bI].id + "</td>";
            bRow += "<td>" + paramArray[bI].name + "</td>";
            bRow += "<td>" + paramArray[bI].username + "</td>";
            bRow += "<td>" + paramArray[bI].email + "</td>";
            bRow += "<td>" + paramArray[bI].address.suite + "," + paramArray[bI].street + "," + paramArray[bI].address.city + "</td>";
            bRow += "<td>" + paramArray[bI].address.zipcode + "</td>";
            bRow += "<td>" + paramArray[bI].phone + "</td>";
            bRow += "<td>" + paramArray[bI].company.name + "</td>";
            bRow += "<td>" + "<button class='btn btn-success btn-detail' data-id='" + paramArray[bI].id + "'> Chi Tiết</button>" + "</td>";
            bRow += "</tr>";
            $("#table-users").append(bRow);
        }
    }
    function getFilterUser(paramDataUser) {
        paramDataUser.name = $("#inp-name").val();
    }
    function checkFilterData(paramDataUser) {
        if (paramDataUser.name == "") {
            alert("Điền tên user cần filter!");
            return false;
        }
        return true;
    }
    function findUserByFilter(paramObjFilter) {

        const bArrResultObj = [];

        if (paramObjFilter.name != "") {
            for (let bI = 0; bI < gUsersArr.length; bI++) {
                const bItemUserObj = gUsersArr[bI];
                if (paramObjFilter.name === bItemUserObj.name) {
                    bArrResultObj.push(bItemUserObj);
                }
            }
        }
        return bArrResultObj;
    }
</script>

</html>